<template>
  <div>
    <div>

      <h1>Dodaj przegląd:</h1>

      <form
          v-on:submit.prevent="submitForm"
      >

        <div class="form-group">

          <div v-if="wasSubmitted && !form.collectionDate">
            <p style="color: red;">Uzupełnij: </p>
          </div>

          <label for="inspectionDate">Data przeglądu:</label>
          <vue-englishdatepicker id="inspectionDate" v-model="form.inspectionDate"/>
        </div>

        <div class="form-group">
          <label for="notes">Notatki:</label>
          <input type="text" class="form-control" id="notes" placeholder="Notatki"
                 v-model="form.notes" required maxlength="255">
        </div>

        <div class="form-group">
          <label for="feeding">Był podkarmiany?</label>
          <input type="checkbox" unchecked-value="false" id="feeding" v-model="form.feeding"
                 value="false">
        </div>

        <div class="form-group">
          <label for="queen">Była matka?</label>
          <input type="checkbox" unchecked-value="false" id="queen" v-model="form.queen"
                 value="false">
        </div>

        <div class="form-group">
          <label for="treatment">Był leczony?</label>
          <input type="checkbox" unchecked-value="false" id="treatment" v-model="form.treatment"
                 value="false">
        </div>

        <div class="form-group">
          <button class="btn btn-primary">Dodaj</button>
        </div>
      </form>
    </div>

  </div>
</template>

<script>
import InspectionService from '../../services/inspection.service';
import inspectionobject from "@/models/inspectionobject";
import VueEnglishdatepicker from 'vue-englishdatepicker';

import 'vue-slider-component/theme/antd.css'

export default {
  name: 'AddInspection',
  components: {
    VueEnglishdatepicker,
  },
  data() {
    return {
      content: '',
      form: new inspectionobject('', false, false, false, '', ''),
      wasSubmitted: false,
    };
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  mounted() {

  },
  methods: {
    submitForm() {

      if (!this.currentUser) {
        this.$router.push('/login');
      } else {

        this.wasSubmitted = true


        if (!this.currentUser) {
          this.$router.push('/login');
        } else if (this.$route.query.beehiveId) {

          if (this.checkObject()) {

            this.form.beehiveId = this.$route.query.beehiveId;


            InspectionService.addNewInspection(this.form).then(
                response => {
                  this.content = response.data;

                  alert('Przegląd dodany poprawnie!')

                  this.$router.push('/beehive?beehiveid=' + this.$route.query.beehiveId)

                },
                error => {
                  this.content =
                      (error.response && error.response.data && error.response.data.message) ||
                      error.message ||
                      error.toString();
                }
            );
          } else
            alert('Uzupełnij brakujące dane!')
        }
      }
    },

    checkObject() {
      if (
          !this.form.inspectionDate ||
          !this.form.notes
      )
        return false
      else
        return true
    }
  }
};
</script>

<style scoped>
label {
  display: block;
  margin-top: 10px;
}
</style>